## 问题发现

在有了轻量化C编译器后发现如果有一个文字处理程序就会更好，于是我们将目标指向了`busybox`的`vi`模块，通过这个可以实现在自己操作系统上写程序并编译，自产自销。

但是在支持`vi`的时候发现输入`i`进入输入模式时无论输入什么都没用，输入界面卡在下面这个界面：

![](./assets/vi-no%20output-1.png)

## 问题原因

我们首先怀疑是没有任何read的操作导致没有输出，所以我们追踪调试了系统调用，发生有read的情况，而且非常正常，输入的都对应上了，所以问题不太可能是没有输入的情况。

我们在Debian调用strace追踪系统调用执行相同操作后发现系统调用行为与我们相同，就是多了write输出的部分，说明我们可能没有完善支持相关系统调用导致的。

![](./assets/vi-no%20output-2.png)

起初我们以为是ioctl没有控制好终端的一些属性才导致的，但是实际情况上没有任何区别。

我们曾经尝试追踪源码，但是追踪停在了fflush函数不知道怎么继续debug，最后对着系统调用逐条对比发现：

我们早期写`ppoll`系统调用时实现比较简单，没有处理系统调用超时的情况，而用户程序可能需要通过超时来判断终端是否空闲。

完善了系统调用后`vi`就能正常输入了。

![](./assets/vi-no%20output-3.png)