#![no_std]
#![no_main]
use user_lib::{exec, exit, fork, wait, waitpid, yield_, shutdown};

#[no_mangle]
#[link_section = ".text.entry"]
pub extern "C" fn _start() -> ! {
    exit(main());
}

#[no_mangle]
fn main() -> i32 {
    let bash_path = "bash\0";
    let environ = [
        "SHELL=/bash\0".as_ptr(),
        "PWD=/\0".as_ptr(),
        "LOGNAME=root\0".as_ptr(),
        "MOTD_SHOWN=pam\0".as_ptr(),
        "HOME=/root\0".as_ptr(),
        "LANG=C.UTF-8\0".as_ptr(),
        "TERM=vt220\0".as_ptr(),
        "USER=root\0".as_ptr(),
        "SHLVL=0\0".as_ptr(),
        "OLDPWD=/root\0".as_ptr(),
        "PS1=\x1b[1m\x1b[32mNPUCore\x1b[0m:\x1b[1m\x1b[34m\\w\x1b[0m\\$ \0".as_ptr(),
        "_=/bin/bash\0".as_ptr(),
        "PATH=/:/bin\0".as_ptr(),
        "LD_LIBRARY_PATH=/\0".as_ptr(),
        core::ptr::null(),
    ];
    let schedule = [
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "echo aaa > lat_sig\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "./openat\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "./dup2\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "./pipe\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "./getppid\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "brk\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "./chdir\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "clone\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "./close\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "./dup\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "./execve\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "./exit\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "./fork\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "./fstat\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "./getcwd\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "./getdents\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "./getpid\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "./gettimeofday\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "./mkdir_\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "./mmap\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "./mount\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "./munmap\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "./open\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "./read\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "./times\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "./umount\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "./uname\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "./unlink\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "./wait\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "./waitpid\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "./write\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "./yield\0".as_ptr(),
            core::ptr::null(),
        ],
        [
            bash_path.as_ptr(),
            "-c\0".as_ptr(),
            "./sleep\0".as_ptr(),
            core::ptr::null(),
        ],
    ];
    let mut exit_code: i32 = 0;
    for argv in schedule {
        let pid = fork();
        if pid == 0 {
            exec(bash_path, &argv, &environ);
        } else {
            waitpid(pid as usize, &mut exit_code);
        }
    }
    // loop {
    //     wait(&mut exit_code);
    // }
    shutdown();
    0
}
